/****************************
 * IBM Confidential
 * Licensed Materials - Property of IBM
 *
 * IBM Rational Developer Traveler
 *
 * (C) Copyright IBM Corporation 2013.
 *
 * The source code for this program is not published or otherwise divested of its trade secrets, 
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
/*******************************************************************************
 * @license
 * Copyright (c) 2010, 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials are made 
 * available under the terms of the Eclipse Public License v1.0 
 * (http://www.eclipse.org/legal/epl-v10.html), and the Eclipse Distribution 
 * License v1.0 (http://www.eclipse.org/org/documents/edl-v10.html). 
 * 
 * Contributors: IBM Corporation - initial API and implementation
 *               Alex Lakatos - fix for bug#369781
 ******************************************************************************/
/*global document window navigator define */

define([], function() {

	var COBOL_KEYWORDS =
		["ACCEPT", "ACCESS", "ADD", "ADDRESS", "ADVANCING", "AFTER", "ALL", "ALPHABET", "ALPHABETIC", "ALPHABETIC-LOWER", "ALPHABETIC-UPPER", "ALPHANUMERIC", "ALPHANUMERIC-EDITED", 
		 "ALSO", "ALTER", "ALTERNATE", "AND", "ANY", "APPLY", "ARE", "AREA", "AREAS", "AS", "ASCENDING", "ASSIGN", "AT", "AUTHOR", "BASIS", "BEFORE", "BEGINNING", "BINARY", "BLANK", 
		 "BLOCK", "BOTTOM", "BY", "CALL", "CANCEL", "CBL", "CHARACTER", "CHARACTERS", "CLASS", "CLOSE", "CODE-SET", "COLLATING", "COMMA", "COMMON", "COMP", "COMP-1", "COMP-2", "COMP-3", 
		 "COMP-4", "COMP-5", "COMPUTATIONAL", "COMPUTATIONAL-1", "COMPUTATIONAL-2", "COMPUTATIONAL-3", "COMPUTATIONAL-4", "COMPUTATIONAL-5", "COMPUTE", "CONFIGURATION", "CONTAINS", 
		 "CONTENT", "CONTINUE", "CONVERTING", "COPY", "CORR", "CORRESPONDING", "COUNT", "CURRENCY", "DATA", "DATE", "DATE-COMPILED", "DATE-WRITTEN", "DAY", "DAY-OF-WEEK", "DBCS", 
		 "DEBUG-ITEM", "DEBUGGING", "DECIMAL-POINT", "DECLARATIVES", "DELETE", "DELIMITED", "DELIMITER", "DEPENDING", "DESCENDING", "DISPLAY", "DISPLAY-1", "DIVIDE", "DIVISION", "DLI", 
		 "DOWN", "DUPLICATES", "DYNAMIC", "EBCDIC", "EGCS", "EJECT", "ELSE", "END", "END-ADD", "END-CALL", "END-COMPUTE", "END-DELETE", "END-DIVIDE", "END-EVALUATE", "END-IF", 
		 "END-MULTIPLY", "END-OF-PAGE", "END-PERFORM", "END-READ", "END-RETURN", "END-REWRITE", "END-SEARCH", "END-START", "END-STRING", "END-SUBTRACT", "END-UNSTRING", "END-WRITE", 
		 "END-XML", "ENDING", "ENTRY", "ENVIRONMENT", "EOP", "EQUAL", "ERROR", "EVALUATE", "EVERY", "EXCEPTION", "EXIT", "EXTEND", "EXTERNAL", "FALSE", "FD", "FILE", "FILE-CONTROL", 
		 "FILLER", "FIRST", "FOOTING", "FOR", "FORMAT", "FROM", "FUNCTION", "FUNCTION-POINTER", "GENERATE", "GIVING","GLOBAL", "GO", "GOBACK", "GREATER", "GROUP-USAGE", "HIGH-VALUE", 
		 "HIGH-VALUES", "I-O", "I-O-CONTROL", "ID", "IDENTIFICATION", "IF", "IN", "INDEX", "INDEXED", "INITIAL", "INITIALIZE", "INPUT", "INPUT-OUTPUT", "INSPECT", "INSTALLATION", "INTO",
		 "INVALID", "IS", "JUST", "JUSTIFIED", "KANJI", "KEY", "LABEL", "LEADING", "LEFT", "LENGTH", "LESS", "LINAGE", "LINAGE-COUNTER", "LINE", "LINES", "LINKAGE", "LOCAL-STORAGE", 
		 "LOCK", "LOW-VALUE", "LOW-VALUES", "MEMORY", "MERGE", "MODE", "MODULES", "MORE-LABELS", "MOVE", "MULTIPLE", "MULTIPLY", "NATIONAL", "NATIONAL-EDITED", "NATIVE", "NEGATIVE", 
		 "NEXT", "NO", "NOT", "NULL", "NULLS", "NUMERIC", "NUMERIC-EDITED", "OBJECT", "OBJECT-COMPUTER", "OCCURS", "OF", "OFF", "OMITTED", "ON", "OPEN", "OPTIONAL", "OR", "ORDER",
		 "ORGANIZATION", "OTHER", "OUTPUT", "OVERFLOW", "PACKED-DECIMAL", "PADDING", "PAGE", "PARSE", "PASSWORD", "PERFORM", "PIC", "PICTURE", "POINTER", "POSITION", "POSITIVE", 
		 "PROCEDURE", "PROCEDURES", "PROCEDURE-POINTER", "PROCEED", "PROCESS", "PROCESSING", "PROGRAM", "PROGRAMID", "QUOTE", "QUOTES", "RANDOM", "READ", "RECORD", "RECORDING", 
		 "RECORDS", "RECURSIVE", "REDEFINES", "REEL", "REFERENCE", "RELATIVE", "RELEASE", "RELOAD", "REMAINDER", "REMOVAL", "RENAMES", "REPLACE", "REPLACING", "REPOSITORY", 
		 "RERUN", "RESERVE", "RETURN", "RETURN-CODE", "RETURNING", "REVERSED", "REWIND", "REWRITE", "RIGHT", "ROUNDED", "RUN", "SAME", "SD", "SEARCH", "SECTION", "SECURITY", 
		 "SEGMENT-LIMIT", "SELECT", "SENTENCE", "SEPARATE", "SEQUENCE", "SEQUENTIAL", "SERVICE", "SET", "SHIFT-IN", "SHIFT-OUT", "SIGN", "SIZE", "SKIP1", "SKIP2", "SKIP3", 
		 "SORT", "SORT-CONTROL", "SORT-CORE-SIZE", "SORT-FILE-SIZE", "SORT-MERGE", "SORT-MESSAGE", "SORT-MODE-SIZE", "SORT-RETURN", "SOURCE-COMPUTER", "SPACE", "SPACES", 
		 "SPECIAL-NAMES", "SQL", "STANDARD", "STANDARD-1", "STANDARD-2", "START", "STATUS", "STOP", "STRING", "SUBTRACT", "SUM", "SUPPRESS", "SYMBOL", "SYMBOLIC", "SYNC", 
		 "SYNCHRONIZED", "TABLE", "TALLY", "TALLYING", "TAPE", "TEST", "THAN", "THEN", "THROUGH", "THRU", "TIME", "TIMES", "TITLE", "TO", "TOP", "TRAILING", "TRUE", "TYPE", 
		 "UNIT", "UNSTRING", "UNTIL", "UP", "UPON", "USAGE", "USE", "USING", "VALUE", "VALUES", "VARYING", "WHEN", "WHEN-COMPILED", "WITH", "WORDS", "WORKING-STORAGE", 
		 "WRITE", "WRITE-ONLY", "XML", "ZERO", "ZEROES", "ZEROS", "-INC", "PlusPlusINCLUDE", "SQL-INCLUDE", "SQL-INCLUDE-MISSING-PERIOD", "DFHVALUE", "DFHRESP", "CICS", 
		 "LIKE", "RESULT-SET-LOCATOR", "LOCATOR", "BLOB", "CLOB", "DBCLOB", "BLOB-FILE", "CLOB-FILE", "DBCLOB-FILE", "BLOB-LOCATOR", "CLOB-LOCATOR", "DBCLOB-LOCATOR", "INCLUDE", "ENCODING"];

	var COBOL_FUNCTIONS =
		["ACOS","ANNUITY","ASIN","ATAN","CHAR","COS","CURRENT-DATE","DATE-OF-INTEGER","DATE-TO-YYYYMMDD","DATEVAL","DAY-OF-INTEGER","DAY-TO-YYYYDDD","DISPLAY-OF","FACTORIAL",
		 "INTEGER","INTEGER-OF-DATE","INTEGER-OF-DAY","INTEGER-PART","LENGTH","LOG","LOG10","LOWER-CASE","MAX","MEAN","MEDIAN","MIDRANGE","MIN","MOD","NATIONAL-OF","NUMVAL",
		 "NUMVAL-C","ORD","ORD-MAX","ORD-MIN","PRESENT-VALUE","RANDOM","RANGE","REM","REVERSE","SIN","SQRT","STANDARD-DEVIATION","SUM","TAN","UNDATE","UPPER-CASE","VARIANCE",
		 "WHEN-COMPILED","YEAR-TO-YYYY","YEARWINDOW"];

	function CobolScanner (whitespacesVisible) {
		this.whitespacesVisible = whitespacesVisible;
		this.setText("");
		
		// Scanner constants
		CobolScanner.prototype.UNKOWN = 1;
		CobolScanner.prototype.KEYWORD = 2;
		CobolScanner.prototype.NUMBER = 3;
		CobolScanner.prototype.STRING = 4;
		CobolScanner.prototype.MULTILINE_STRING = 5;
		CobolScanner.prototype.SINGLELINE_COMMENT = 6;
		CobolScanner.prototype.MULTILINE_COMMENT = 7;
		CobolScanner.prototype.WHITE = 9;
		CobolScanner.prototype.WHITE_TAB = 10;
		CobolScanner.prototype.WHITE_SPACE = 11;
		CobolScanner.prototype.TASK_TAG = 14;
		CobolScanner.prototype.FUNCTION = 15;
	}
	
	CobolScanner.COBOL_KEYWORDS = COBOL_KEYWORDS;
	
	CobolScanner.prototype = {
		getOffset: function() {
			return this.offset;
		},
		getStartOffset: function() {
			return this.startOffset;
		},
		getData: function() {
			return this.text.substring(this.startOffset, this.offset);
		},
		getDataLength: function() {
			return this.offset - this.startOffset;
		},
		_default: function(c) {
			switch (c) {
				case 32: // SPACE
				case 9: // TAB
					if (this.whitespacesVisible) {
						return c === 32 ? this.WHITE_SPACE : this.WHITE_TAB;
					}
					do {
						c = this._read();
					} while(c === 32 || c === 9);
					this._unread(c);
					return this.WHITE;
				case 40: // (
				case 41: // )
					// BRACKETS
					return c;
				default:
					var off = this.offset - 1;
					if (48 <= c && c <= 57) {
						var floating = false, exponential = false, hex = false, firstC = c, hasDot = false;
						do {
							c = this._read();
							if (c === 46 /* dot */ && !floating) {
								floating = hasDot = true;
							} else if (c === 101 /* e */ && !exponential) {
								floating = exponential = true;
								c = this._read();
								if (c !== 45 /* MINUS */) {
									this._unread(c);
								}
							} else if (c === 120 /* x */ && firstC === 48 && (this.offset - off === 2)) {
								floating = exponential = hex = true;
							} else if (!(48 <= c && c <= 57 || (hex && ((65 <= c && c <= 70) || (97 <= c && c <= 102))))) { //NUMBER DIGIT or HEX
								// defect 70359, function names can start with a number
								if(!hasDot && ((97 <= c && c <= 122) || (65 <= c && c <= 90) || c === 95 || c === 45)) {
									do {
										c = this._read();
									} while((97 <= c && c <= 122) || (65 <= c && c <= 90) || c === 95 || (48 <= c && c <= 57) || c === 45);
									this._unread(c);
									return this.UNKOWN;
								}
								break;
							}
						} while(true);
						this._unread(c);
						return this.NUMBER;
					}
					if ((97 <= c && c <= 122) || (65 <= c && c <= 90) || c === 95) { //LETTER OR UNDERSCORE OR NUMBER
						do {
							c = this._read();
						} while((97 <= c && c <= 122) || (65 <= c && c <= 90) || c === 95 || (48 <= c && c <= 57) || c === 45);  //LETTER OR UNDERSCORE OR NUMBER OR DASH
						this._unread(c);
						if (COBOL_KEYWORDS.length > 0) {
							var word = this.text.substring(off, this.offset);
							//TODO slow
							for (var i=0; i<COBOL_KEYWORDS.length; i++) {
								if (word.toUpperCase() === COBOL_KEYWORDS[i]) { 
									return this.KEYWORD;
								}
							}
						}
						if (COBOL_FUNCTIONS.length > 0) {
							var word = this.text.substring(off, this.offset);
							//TODO slow
							for (var i=0; i<COBOL_FUNCTIONS.length; i++) {
								if (word.toUpperCase() === COBOL_FUNCTIONS[i]) { 
									return this.FUNCTION;
								}
							}
						}
					}
					return this.UNKOWN;
			}
		},
		_read: function() {
			if (this.offset < this.text.length) {
				return this.text.charCodeAt(this.offset++);
			}
			return -1;
		},
		_unread: function(c) {
			if (c !== -1) { this.offset--; }
		},
		nextToken: function() {
			this.startOffset = this.offset;
			while (true) {
				var c = this._read(), result;
				switch (c) {
					case -1: return null;
					case 10:
					case 13:
						c = this._read();
						if(c === 42 || c === 47) {
							while (true) {
								c = this._read();
								if ((c === -1) || (c === 10) || (c === 13)) {
									this._unread(c);
									return this.SINGLELINE_COMMENT;
								}
							}
						}
						this._unread(c);
						break;
					case 42:
					case 47:
						if(this.offset === 7 || this.offset === 1) { //FIXME
							while (true) {
								c = this._read();
								if ((c === -1) || (c === 10) || (c === 13)) {
									this._unread(c);
									return this.SINGLELINE_COMMENT;
								}
							}
						}
						break;
					case 39:	// SINGLE QUOTE -> char const
						result = this.STRING;
						while(true) {
							c = this._read();
							switch (c) {
								case 39:
									return result;
								case 13:
								case 10:
								case -1:
									this._unread(c);
									return result;
								case 92: // BACKSLASH
									c = this._read();
									switch (c) {
										case 10: result = this.MULTILINE_STRING; break;
										case 13:
											result = this.MULTILINE_STRING;
											c = this._read();
											if (c !== 10) {
												this._unread(c);
											}
											break;
									}
									break;
							}
						}
						break;
					case 34:	// DOUBLE QUOTE -> string
						result = this.STRING;
						while(true) {
							c = this._read();
							switch (c) {
								case 34: // DOUBLE QUOTE
									return result;
								case 13:
								case 10:
								case -1:
									this._unread(c);
									return result;
								case 92: // BACKSLASH
									c = this._read();
									switch (c) {
										case 10: result = this.MULTILINE_STRING; break;
										case 13:
											result = this.MULTILINE_STRING;
											c = this._read();
											if (c !== 10) {
												this._unread(c);
											}
											break;
									}
									break;
							}
						}
						break;
					default:
						return this._default(c);
				}
			}
		},
		setText: function(text) {
			this.text = text;
			this.offset = 0;
			this.startOffset = 0;
		}
	};
	
	function WhitespaceScanner () {
		CobolScanner.call(this, null, true);
	}
	WhitespaceScanner.prototype = new CobolScanner(null);
	WhitespaceScanner.prototype.nextToken = function() {
		this.startOffset = this.offset;
		while (true) {
			var c = this._read();
			switch (c) {
				case -1: return null;
				case 32: // SPACE
					return this.WHITE_SPACE;
				case 9: // TAB
					return this.WHITE_TAB;
				default:
					do {
						c = this._read();
					} while(!(c === 32 || c === 9 || c === -1));
					this._unread(c);
					return this.UNKOWN;
			}
		}
	};
	
	function CommentScanner (whitespacesVisible) {
		CobolScanner.call(this, null, whitespacesVisible);
	}
	CommentScanner.prototype = new CobolScanner(null);
	CommentScanner.prototype.setType = function(type) {
		this._type = type;
	};
	CommentScanner.prototype.nextToken = function() {
		this.startOffset = this.offset;
		while (true) {
			var c = this._read();
			switch (c) {
				case -1: return null;
				case 32: // SPACE
				case 9: // TAB
					if (this.whitespacesVisible) {
						return c === 32 ? this.WHITE_SPACE : this.WHITE_TAB;
					}
					do {
						c = this._read();
					} while(c === 32 || c === 9);
					this._unread(c);
					return this.WHITE;
				case 84: // T
					if ((c = this._read()) === 79) { // O
						if ((c = this._read()) === 68) { // D
							if ((c = this._read()) === 79) { // O
								c = this._read();
								if (!((97 <= c && c <= 122) || (65 <= c && c <= 90) || c === 95 || (48 <= c && c <= 57))) {
									this._unread(c);
									return this.TASK_TAG;
								}
								this._unread(c);
							} else {
								this._unread(c);
							}
						} else {
							this._unread(c);
						}
					} else {
						this._unread(c);
					}
					//FALL THROUGH
				default:
					do {
						c = this._read();
					} while(!(c === 32 || c === 9 || c === -1 || c === 84));
					this._unread(c);
					return this.UNKOWN;
			}
		}
	};
	
	function FirstScanner () {
		CobolScanner.call(this, null, false);
	}
	FirstScanner.prototype = new CobolScanner(null);
	FirstScanner.prototype._default = function(c) {
		while(true) {
			c = this._read();
			switch (c) {
				case 10:
				case 13:
					c = this._read();
					if(c === 42 || c == 47) {
						this._unread();
						this._unread();
						return this.UNKOWN;
					}
					break;
				case 34: // DOUBLE QUOTE
				case 39: // SINGLE QUOTE
				case -1:
					this._unread(c);
					return this.UNKOWN;
			}
		}
	};
	
	return {CobolScanner: CobolScanner, WhitespaceScanner: WhitespaceScanner, FirstScanner: FirstScanner, CommentScanner: CommentScanner};
});