/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/request/xhr", "com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/designFileContent"
], function ( ContentPane, xhr, designFileContent ) {
	return {
		createPane : function ( streamId, fileItemId, compentId, workingProject, project, type, name ) {
			var cp = new ContentPane();
			// Ajax for design file
			var promiseContent = xhr( net.jazz.ajax.contextRoot() + "/service/com.ibm.teampdp.query.engine.common.IRppDesignFileService", {
				method : "POST",
				// synchronous ensure that contentPane of content is well prepared.
				data : {
					streamId : streamId,
					fileItemId : fileItemId,
					compentId : compentId,
					project : project,
					type : type,
					name : name
				},
				handleAs : "json"
			} ).then( function ( data ) {
				cp.addChild( designFileContent.getDesignFileContent( data, type, workingProject, streamId, compentId, fileItemId ) );
				return cp;
			}, function ( err ) {
				displayRppError( err );
				return cp;
			} );
			return promiseContent;
		}
	};
} );