/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "./dataStructureOverview", "./entitiesSelectionLinesPane", "./gLinesPane", "./keywordsPane", "./dataStructureDefinition",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, dataStructureOverview, entitiesSelectionLinesPane, gLinesPane, keywordsPane, dataStructureDefinition, PTEditor, PacbaseEditor ) {
	return {
		getDataStructureTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( dataStructureOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// set the data unit definition
			var dataExtension = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase" && object[ "class" ] === "PacDataUnit";
			} );
			if ( dataExtension.length === 1 ) {
				// definition
				var cpDefinition = new ContentPane( {
					title : PacbaseEditor.DATA_STRUCTURE_EDIT_SECTION_HEADER,
				} );
				cpDefinition.addChild( dataStructureDefinition.getOverviewDefinition( dataExtension[ 0 ], type ) );
				tc.addChild( cpDefinition );
			}

			// LS lines
			var cpLSLines = new ContentPane( {
				title : PacbaseEditor.LSLINE_TABTEXT,
			} );
			
			cpLSLines.addChild( entitiesSelectionLinesPane.getDetailLines( data, type, project, streamId, compentId, fileItemId, PacbaseEditor.LSLINE_SECTION_HEADER, PacbaseEditor.LSLINE_SECTION_DESCRIPTION, 
					PacbaseEditor.LSLINE_SEGMENT,PacbaseEditor.LSLINE_COLUMN_TOOL_TIP_SELECTED_LIST) );
			tc.addChild( cpLSLines );

			// G lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			var extensions = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase" && object[ "class" ] == "PacDataUnit";
			} );
			if ( extensions.length === 1 ) {
				cpGLines.addChild(  gLinesPane.getGLines( extensions[ 0 ], type, true, true, false, false, streamId, project ) );
			}
			tc.addChild( cpGLines );

			// keywords
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data.keywords, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );