/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", 
		"./dataElementTab", "./segmentTab", "./dataStructureTab", 
		"./programTab", "./macroTab", "./dialogTab", "./screenTab",
		"./textTab", "./libraryTab", "./reportTab", "./errorLabelTab","./copybookTab", "./dialogFolderTab", "./folderTab", "./blockbaseTab", "./defaultTab"
], function ( ContentPane, dataElementTab, segmentTab, dataStructureTab, programTab, macroTab, dialogTab, screenTab, textTab, libraryTab, reportTab, errorLabelTab, copybookTab, dialogFolderTab, folderTab, blockbaseTab, defaultTab ) {
	return {
		getDesignFileContent : function ( data, type, project, streamId, compentId, fileItemId ) {
			var cp = new ContentPane();
			if ( type === "dataelement" ) {
				cp = dataElementTab.getDataElementTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "dataaggregate" ) {
				cp = segmentTab.getSegmentTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "dataunit" ) {
				cp = dataStructureTab.getDataStructureTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacprogram" ) {
				cp = programTab.getProgramTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacmacro" ) {
				cp = macroTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacdialog" ) {
				cp = dialogTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacscreen" ) {
				cp = screenTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pactext" ) {
				cp = textTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "paclibrary" ) {
				cp = libraryTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;	
			} else if ( type === "pacreport" ) {
					cp = reportTab.getTab( data, type, project, streamId, compentId, fileItemId );
					return cp;		
			} else if ( type === "pacerrorlabel" ) {
				cp = errorLabelTab.getTab( data, type, project, streamId, compentId, fileItemId );
		        return cp;		
			} else if ( type === "paccopybook" ) {
				cp = copybookTab.getTab( data, type, project, streamId, compentId, fileItemId );
		        return cp;		
			} else if ( type === "pacdialogfolder" ) {
				cp = dialogFolderTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacfolder" ) {
				cp = folderTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacblockbase" ) {
				cp = blockbaseTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else {
				cp = defaultTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;								
			}
		}
	};
} );