/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  "./dialogOverview", "./dialogDefinition", "./dialogComplement", "./keywordsPane", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, dialogOverview, dialogDefinition, dialogComplement, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( dialogOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( dialogDefinition.getDetailDefinition( data, type ) );
			tc.addChild( cpDefinition );			

			// Complement du dialogue
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.DIALOG_COMPLEMENT,
			} );
			cpDefinition.addChild( dialogComplement.getDetailDefinition( data, type, project, streamId ) );
			tc.addChild( cpDefinition );			

			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, true, true, true, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords
			var keywords = data.keywords;
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( keywords, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );