/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, PacbaseEditor, typeDict ) {

	return {
		getOverviewLibraryCall : function ( generationParameter, type, project, streamId ) {
			var overviewGenerationParameter;
			require( [
				"dojo/string"
			], function ( string ) {
				overviewGenerationParameter = new ContentPane( {
					content : "<hr><strong>" + PacbaseEditor.LIBRARY_CALL_SECTION_HEADER + ": </strong><P>"
							+ string.substitute( PacbaseEditor.LIBRARY_CALL_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			var generationParameterPane = new ContentPane();
			if ( generationParameter != "" ) {
				generationParameterPane.addChild(
						new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("",  generationParameter, true, streamId, project));
			} else {
				generationParameterPane.set( "content", "<p>" + PacbaseEditor.NO_LIBRARY + "</p>" );
			}
			overviewGenerationParameter.addChild( generationParameterPane );
			return overviewGenerationParameter;
		}
	};
} );