/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
	"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( typeDict ) {
	return {
		topLevelProject : function ( resultJSONSearch, streamId, streamName ) {
			var projects = [];
			var types = [];
			var resultJSONProject = [];
			// Set root
			resultJSONProject.push( {
				id : streamId,
				name : streamName,
				model : "stream",
				root : true
			} );
			for ( var i = 0; i < resultJSONSearch.length; i++ ) {
				var result = resultJSONSearch[ i ];
				var project = result.project;
				var typeProject = result.type + "/" + project;
				if ( projects.indexOf( project ) == -1 ) {
					resultJSONProject.push( {
						id : project,
						name : project,
						model : "project",
						parent : streamId
					} );
					projects.push( project );
				}
				if ( types.indexOf( typeProject ) == -1 ) {
					resultJSONProject.push( {
						id : typeProject,
						name : typeDict[ result.type ],
						model : "type",
						parent : project
					} );
					types.push( typeProject );
				}
				resultJSONProject.push( {
					id : result.name,
					name : result.name,
					model : "instance",
					parent : typeProject,
					type : result.type,
					label : result.label,
					fileItemId : result.fileItemId,
					compentId : result.compentId,
					project : result.project,
					metaType : result.metaType,
				} );
			}
			return resultJSONProject;
		}
	};
} );