/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor"
], function ( ContentPane, PacbaseEditor ) {	
	return {
		getDetailCommentLines : function ( commentLines) {
			var detailCommentLines;
			require( [
				"dojo/string"
			], function ( string ) {
				detailCommentLines = new ContentPane( {
					content : "<strong>" + PacbaseEditor.MACRO_COMMENTS_LINES + ": </strong><hr><P>"
							+ string.substitute( PacbaseEditor.COMMENTLINES_EDIT_SECTION_DESCRIPTION ) + "</p>",
							style : {
								'overflow' : 'auto',
							},
				} );
			} );
						
			require( [
					'dojox/grid/DataGrid', 'dojo/data/ItemFileReadStore'
			], function ( DataGrid, ItemFileReadStore ) {
				/* set up data store */
				var store = new ItemFileReadStore( {
					data : {
						items : commentLines
					}
				} );	
				
				/* set up layout */	
				var layout = [
						{
							'name' : PacbaseEditor.MACRO_COMMENTS_LINES,
							'field' : 'commentLine',
							'width' : '600px',
							formatter : function ( commentLine ) {
								if ( commentLine != "" ) {
									var res = commentLine.replace(/ /g,"&nbsp;");									
									return  "<div>"+ res + "</div>";
								}
							},
						}
				];

				/* create a new grid */
				var commentLinesGrid = new DataGrid( {
					store : store,
					structure : layout,
					height : ( rppCurrentPaneGridHeight ) + "px",
					autoWidth : true,	
					onStyleRow: function (row) {
						row.customClasses = "rppGridFixedDefaultFont";
					},
					selectable : true,
					canSort : function () {
						return false;
					}
				} );			

				detailCommentLines.addChild( commentLinesGrid );
			} );
			return detailCommentLines;
		}
	};
	
} );