/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/Textarea",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, Textarea, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseSource (source, type, project, streamId, compentId, fileItemId  ) {
		var definitionTable = new TableContainer( {
			labelWidth : 150,
			customClass: "rppMacroSourceLabelsAndValues",
		} );

		var macroSourceViewer = 
			new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.OrionViewerWidget("", 
					source, type, project, streamId, compentId, fileItemId, false, rppCurrentPaneHeight - 125);
		
		definitionTable.addChild( macroSourceViewer );
		
		return definitionTable;
	}

	return {
		getDetailSource : function ( source, type, project, streamId, compentId, fileItemId   ) {
			var sourceTable;
			require( [
				"dojo/string"
			], function ( string ) {
				sourceTable = new ContentPane( {
					content : "<strong>Source: </strong><hr>",
				} );
			} );
			sourceTable.addChild( baseSource(source, type, project, streamId, compentId, fileItemId  ) );

			return sourceTable;
		}
	};
} );