/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, CheckBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data) {
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );

		var programID = new TextBox( {
			label : PacbaseEditor.PROGRAM_PROGRAM_ID,
			value : data.programID,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( programID );

		
		var variante = new TextBox( {
			label : PacbaseEditor.PROGRAM_VARIANTE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.variante),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( variante );
		
		var programStructure = new TextBox( {
			label : PacbaseEditor.PROGRAM_STRUCTURE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.programStructure),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( programStructure );
		
		var presenceValidation = new TextBox( {
			label : PacbaseEditor.PROGRAM_PRESENCE_VALIDATION,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.presenceValidation),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( presenceValidation );
		
	    var sqlIndicator = new CheckBox({
	    	label: PacbaseEditor.PROGRAM_SQLIndicator,
	        checked: data.SQLIndicator == "true",
	        disabled : true
	    });
	    definitionTable.addChild( sqlIndicator );
	    
		return definitionTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId  ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content : "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + ": </strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data) );

			return detailDefinition;
		}
	};
} );