/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "./programOverview", "./programDefinition", "./programCDLines", "./cpLinesPane", "./keywordsPane", "./gLinesPane", 
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, programOverview, programDefinition, programCDLines, cpLinesPane, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getProgramTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( programOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );

			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( programDefinition.getDetailDefinition( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpDefinition );
			
			// CD Lines
			var cpCDLines = new ContentPane( {
				title : PacbaseEditor.CDLINE_TABTEXT,
			} );
			cpCDLines.addChild( programCDLines.getDetailCDLines( data.CDLines , type, project, streamId ) );
			tc.addChild( cpCDLines );
			
			// CP Lines
			var cpCPLines = new ContentPane( {
				title : PacbaseEditor.CPLINE_TABTEXT,
			} );
			cpCPLines.addChild( cpLinesPane.getCPLines( data.CPLines, type, streamId, project ) );
			tc.addChild( cpCPLines );
			
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, true, false, true, streamId, project ) );
			tc.addChild( cpGLines );			

			// Keywords
			var keywords = data.keywords;
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( keywords, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );