/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/string", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel"
], function ( ContentPane, string, PacbaseEditor, typeDict, PacEnumerationLabel ) {
	return {
		getOverviewSSLines : function ( ssLines, type ) {
			var overviewSSLines = new ContentPane( {
				content : "<hr><strong>" + PacbaseEditor.SSLINE_SECTION_HEADER + ": </strong><P>"
						+ string.substitute( PacbaseEditor.SSLINE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
			} );

			if ( ssLines.length != 0 ) {
				var SSLinesContent = "<ul>"
					ssLines.forEach( function ( ssLine ) {
					SSLinesContent += "<li>";
//					if ( ssLine.dataDefinition != undefined && ssLine.dataDefinition != "" ) {
//						var dataDefinition = component.dataDefinition;
//						SSLinesContent += dataDefinition[ "name" ] + " (";
//						SSLinesContent += typeDict[ dataDefinition[ "class" ] ] + ") ";
//						SSLinesContent += dataDefinition[ "label" ];
//					}
					SSLinesContent += "</li>";
				} );
				SSLinesContent += "</ui>";
				var SSLinesPane = new ContentPane( {
					content : SSLinesContent,
					style : {
						height : "100px"
					}
				} );
				overviewSSLines.addChild( SSLinesPane );
			}
			return overviewSSLines;
		},

		getDetailSSLines : function ( ssLines, type ) {
			var detailSSLines = new ContentPane( {
				content : "<strong>" + PacbaseEditor.SSLINE_TABLE_SECTION_HEADER + ": </strong><hr><P>"
						+ string.substitute( PacbaseEditor.SSLINE_TABLE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
			} );
			if ( ssLines.length != 0 ) {
				require( [
						'dojox/grid/DataGrid', 'dojo/data/ItemFileWriteStore'
				], function ( DataGrid, ItemFileWriteStore ) {
					/* set up data store */
					var store = new ItemFileWriteStore( {
						data : {
							items : ssLines
						}
					} );
					/* set up layout */
					var layout = [
						{
							name : PacbaseEditor.SSLINE_LINE_TYPE,
							field : "tableLineType",
							width : "25%",
							formatter : function ( tableLineType ) {
								if ( tableLineType != undefined ) {
									return PacEnumerationLabel[tableLineType["class"] + tableLineType["value"]];
								}
							},
						},
						{
							name : PacbaseEditor.SSLINE_SUBSCHEMA_OR_SYSTEM_NAME,
							field : "subSchemaOrSystemName",
							width : "25%",
						},
						{
							name : PacbaseEditor.SSLINE_NUMBER,
							field : "number",
							width : "25%",
						},
						{
							name : PacbaseEditor.SSLINE_MAX_OCCUR_NUMBER,
							field : "maxOccurrencesNumber",
							width : "25%",
						},						
					];

					/* create a new grid */
					var SSLinesGrid = new DataGrid( {
						store : store,
						structure : layout,
						autoHeight : true,
						style : {
							'overflow' : 'auto',
						},
						selectable : true,
						canSort : function () {
							return false;
						}
					} );
					detailSSLines.addChild( SSLinesGrid );
				} );
			}
			return detailSSLines;
		}
	};
} );